// psync
// commit filesystem caches to disk, and give an indication of the progress.
// shows the amount of data that hasn't been flushed yet.
//
// aTc <aTc@k-n-p.org>
// tarzeau <alex@aiei.ch> C++ to C

#include <unistd.h>
#include <stdio.h>

bool done=false;

void sync_progress()
{
    int togo=0;

    //cout.precision(2);
    //cout << std::fixed;

    while(!done)
    {
        ifstream infile("/proc/meminfo");
        string line;
        while (getline(infile,line))
        {

            if(line.find("Dirty:") != string::npos)
            {
                stringstream str(line);
                string s1,s2;
                str >> s1 >> togo >> s2;

                //cout << "\r" << togo/1024.0 << " MB left   ";
		printf("\r%0.2 MB left   ", togo/1024.0);
                //cout.flush();
		fflush(stdout);
                break;
            }
        }
    infile.close();
    this_thread::sleep_for(chrono::seconds(1));
    }

}


int main()
{
    std::thread syncthread(sync_progress);

    sync();
    done=true;
    syncthread.join();
    //cout << "\rSynced                    " << endl;
    printf("\rSynced                    ");
}
